@echo off
setlocal enabledelayedexpansion
rem set current folder
cd /d %~dp0

rem executable batch file
set phits_bat="c:\phits\bin\phits.bat"

rem input file name (D:autorun.inp)
if "%1" == "" (
   set inpfile=autorun.inp
) else (
   set inpfile=%~1
)
title ANATALLY: %inpfile%

rem set default parameters
set phitsinput=phits.inp
rem set tallyfolder=tallyout
set tallyfolder=outfiles
set manatally=1
set ncycle=1
set irestart=0

rem Count of "set"
set nset=0
rem Count of node data
set rdflg=-1
rem Count of "ci"
set cnum=0

for /f "delims=" %%a in (%inpfile%) do (
   
   set line=%%a
   rem subroutine SPLIT : dc=d[] address, d[1]=parameter name, d[2]=parameter value
   call :SPLIT "!line!"
   
   if !dc! equ 0 goto ReadLpEnd

   rem file (Input file name of phits code, icntl=16)
   if /i "!d[1]!" == "file" (
      if !rdflg! geq 0 exit /b 1
      set phitsinput=!d[2]!
      
   ) else if /i "!d[1]!" == "tallyfolder" (
      if !rdflg! geq 0 exit /b 1
      rem echo tallyfolder=!d[2]!
      
   ) else if /i "!d[1]!" == "manatally" (
      if !rdflg! geq 0 exit /b 1
      set manatally=!d[2]!
      
   ) else if /i "!d[1]!" == "ncycle" (
      if !rdflg! geq 0 exit /b 1
      set ncycle=!d[2]!
      
   ) else if /i "!d[1]!" == "irestart" (
      if !rdflg! geq 0 exit /b 1
      set irestart=!d[2]!
      
   ) else if /i "!d[1]!" == "set" (
      if !rdflg! geq 0 exit /b 1
      set cnum=!d[2]:~1!
      rem set cset[!cnum!]=!d[2]:~1!
      set /a nset+=1
      
   ) else if /i "!d[1]!" == "c-type" (
      if !rdflg! geq 0 exit /b 1
      set ctype[!cnum!]=!d[2]!
      set ctype[0]=!d[2]!
      
   ) else if /i "!d[1]!" == "cmin" (
      if !rdflg! geq 0 exit /b 1
      if !ctype[0]! equ 1 exit /b 1
      set cmin[!cnum!]=!d[2]!
      
   ) else if /i "!d[1]!" == "cmax" (
      if !rdflg! geq 0 exit /b 1
      if !ctype[0]! equ 1 exit /b 1
      set cmax[!cnum!]=!d[2]!
      
   ) else if /i "!d[1]!" == "nc" (
      if !rdflg! geq 0 exit /b 1
      if !ctype[0]! equ 1 (
         set nc[!cnum!]=!d[2]!
         set nc[0]=!d[2]!
         set rdflg=0
      ) else if !ctype[0]! leq 3 (
         set nc[!cnum!]=!d[2]!
         set nc[0]=!d[2]!
         set rdflg=-1
      ) else (
         exit /b 1
      )
      
   ) else if /i "!d[1]!" == "cdel" (
      if !rdflg! geq 0 exit /b 1
      if !ctype[0]! equ 4 (
         set cdel[!cnum!]=!d[2]!
      ) else if !ctype[0]! equ 5 (
         set cdel[!cnum!]=!d[2]!
      ) else (
         exit /b 1
      )
      
   ) else if "!line:=~0,1!" == "[" (
      if !rdflg! geq 0 exit /b 1
      goto ReadLpOut
      
   ) else if !ctype[0]! equ 1 if !rdflg! geq 0 (
      for /l %%i in (1,1,!dc!) do (
         set /a add=!rdflg!+%%i
         set rdata[!cnum!][!add!]=!d[%%i]!
      )
      set /a rdflg+=!dc!
      if !rdflg! geq !nc[0]! (
         set rdflg=-1
      )
      
   )
   
   :ReadLpEnd
   rem next line read
)
:ReadLpOut
rem release the work variables
set cnum=
set ctype[0]=
set nc[0]=


rem total product of each "ci"
rem signc is the total product of nc
set signc=0
for /f "tokens=1-3 delims=[]=" %%a in ('set ctype ^| findstr /r ctype\[.*\]') do (
rem ctype[add]=value : %%a=ctype, %%b=add, %%c=value
   if %%c gtr 0 (
      if %%c equ 4 (
         set nc[%%b]=1
      ) else if %%c equ 5 (
         set nc[%%b]=1
      )
      if !signc! gtr 0 (
         set /a signc=!signc!*!nc[%%b]!
      ) else (
         set signc=!nc[%%b]!
      )
   )
   rem echo signc !signc!
)

rem check signc(total product)
if not defined signc (
   echo total nc is smaller than 1
   timeout /t -1
   exit /b 1
)
if %signc% lss 1 (
   echo total nc is smaller than 1
   timeout /t -1
   exit /b 1
)

rem ............... write anatally parameter file (nc_info.inp) ...............

echo %nset% >nc_info.inp

for /f "tokens=1-3 delims=[]=" %%a in ('set ctype ^| findstr /r ctype\[.*\]') do (
rem ctype[add]=value : %%a=ctype, %%b=add, %%c=value
   if %%c gtr 0 (
      echo set: c%%b >>nc_info.inp
      echo c-type = %%c >>nc_info.inp
   
      rem c-type = 1
      if %%c equ 1 (
         echo nc = !nc[%%b]! >>nc_info.inp
         
         for /l %%j in ( 1,1,!nc[%%b]! ) do (
            echo !rdata[%%b][%%j]! >>nc_info.inp
         )
      
      rem c-type = 2
      ) else if %%c equ 2 (
         echo nc = !nc[%%b]! >>nc_info.inp
         echo cmin = !cmin[%%b]! >>nc_info.inp
         echo cmax = !cmax[%%b]! >>nc_info.inp
      
      rem c-type = 3
      ) else if %%c equ 3 (
         echo nc = !nc[%%b]! >>nc_info.inp
         echo cmin = !cmin[%%b]! >>nc_info.inp
         echo cmax = !cmax[%%b]! >>nc_info.inp
      
      rem c-type = 4
      ) else if %%c equ 4 (
         echo cdel = !cdel[%%b]! >>nc_info.inp
         echo cmin = !cmin[%%b]! >>nc_info.inp
         echo cmax = !cmax[%%b]! >>nc_info.inp
      
      rem c-type = 5
      ) else if %%c equ 5 (
         echo cdel = log^(!cdel[%%b]!^) >>nc_info.inp
         echo cmin = !cmin[%%b]! >>nc_info.inp
         echo cmax = !cmax[%%b]! >>nc_info.inp
      )
   )
   rem echo ci=c%%b
)

rem ****************************************************************************************
rem Pre-analysis (icntl=16 : phits.inp)
rem make temporally phits input file
rem (icntl=0  : phits_tmp.inp file)
rem (icntl=17 : anatally.inp file)

rem call %phits_bat%phits.bat %phitsinput%
call %phits_bat% %phitsinput%

if not exist phits_tmp.inp (
   echo;
   echo Error of autorun: phits_tmp.inp is not found.
   rem pause
   timeout /t -1
)

rem ****************************************************************************************


rem read folder & file info ( serch anatally sub-section in anatally_tmp.inp )
set cflag=0
set nfolder=0
set nsfile=0
set nanatally=0
for /f "delims=" %%a in (anatally_tmp.inp) do (
   set line=%%a
   
   if !cflag! equ 4 (
rem   set word=!line:~1,12!
      set word=!line:~0,12!
      if /i "!word!" == "anatally end" (
         set cflag=1
      
      ) else (
         set /a nfolder+=1
         rem subroutine FileName : set to fname, folder[nfolder], outname[nfolder], extname[nfolder]
         call :FileName "!line:~1!"

      )
   ) else if !cflag! equ 2 (
rem   set word=!line:~1,5!
      set word=!line:~0,5!
      if /i "!word!" == "sfile" (
         set /a nsfile+=1
rem      set wsfile=!line:~7!
         set wsfile[!nsfile!]=!line:~6!
         set cflag=3
      )
   ) else if !cflag! equ 3 (
      set word=!line:~1,5!
      if /i "!word!" == "nfile" (
         set wnfile=!line:~9!
         set cflag=4
      )
   ) else if !cflag! leq 1 (
rem   set word=!line:~1,14!
      set word=!line:~0,14!
      if /i "!word!" == "anatally start" (
         set cflag=2
         set /a nanatally+=1
      )
   )
)

rem ncp is the total product after correction
if %nanatally% gtr 0 (
   set /a ncp=%nfolder%/%nanatally%

rem no-anatally sub section
) else (
   rem set /a nfolder=%nc[1]%
   set /a nfolder=!signc!
   set /a ncp=!nfolder!
   for /l %%i in ( 1,1,!nfolder! ) do (
      set foldercount=000000%%i
      if !ncp! geq 100000 (
         set foldercount=!foldercount:~-6!
      ) else if !ncp! geq 10000 (
         set foldercount=!foldercount:~-5!
      ) else if !ncp! geq 1000 (
         set foldercount=!foldercount:~-4!
      ) else if !ncp! geq 100 (
         set foldercount=!foldercount:~-3!
      ) else if !ncp! geq 10 (
         set foldercount=!foldercount:~-2!
      ) else (
         set foldercount=!foldercount:~-1!
      )
      set folder[%%i]=!tallyfolder!\!foldercount!\
      rem echo folder=!folder[%%i]!
   )
)
rem echo nfolder   %nfolder%
rem echo nanatally %nanatally%
rem echo ncp       %ncp%

rem make directory to store outpot files
mkdir  %tallyfolder% > NUL 2>&1


rem ============================ start of loop of analysis =================================
set i_cycle=1

:CycleStart
if %i_cycle% gtr %ncycle% ( goto CycleEnd )
   echo Autorun loop count !i_cycle!
   
   rem make batch_a.out file ( loop stelling file for ncycle )
   if %i_cycle% equ 1 (
      echo %ncycle% > batch_a.out
   )


rem ------------------------ start of loop of variable parameter ---------------------------
rem start of loop of variable parameter
   set counter=1
   rem echo loop param : %counter% %ncp%
   
   :AnaStart
   if %counter% gtr %ncp% ( goto AnaEnd )
      echo    Calculating with condition %counter%


rem set each ci variable counter
      set foldercount=000000%counter%
      if %ncp% geq 100000 (
         set foldercount=%foldercount:~-6%
      ) else if %ncp% geq 10000 (
         set foldercount=%foldercount:~-5%
      ) else if %ncp% geq 1000 (
         set foldercount=%foldercount:~-4%
      ) else if %ncp% geq 100 (
         set foldercount=%foldercount:~-3%
      ) else if %ncp% geq 10 (
         set foldercount=%foldercount:~-2%
      ) else (
         set foldercount=%foldercount:~-1%
      )

rem make directory to store output files of each condition
      if %i_cycle% equ 1 if %irestart% equ 0 (
         mkdir !tallyfolder!\!foldercount! > NUL 2>&1

rem copy previous result file to current folder
      ) else (
         for /l %%i in ( 1,1,!nfolder! ) do (
            if /i "!tallyfolder!\!foldercount!\" == "!folder[%%i]!" (
               if exist !folder[%%i]!!outname[%%i]!!extname[%%i]! (
                copy /y !folder[%%i]!!outname[%%i]!!extname[%%i]! !outname[%%i]!!extname[%%i]! > NUL 2>&1
               )
               if exist !folder[%%i]!!outname[%%i]!_err!extname[%%i]! (
                copy /y !folder[%%i]!!outname[%%i]!_err!extname[%%i]! !outname[%%i]!_err!extname[%%i]! > NUL 2>&1
               )
            )
         )

      )


rem rename set:Ci[**] files ( varlist_??.inp ---> varfile.inp )
      if exist varfile_!foldercount!.inp (
       copy /y varfile_!foldercount!.inp varfile.inp > NUL 2>&1
      ) else (
       echo not found varfile_!foldercount!.inp
       timeout /t -1
       exit /b 3
      )


rem ****************************************************************************************
rem perform parameter analysis (icntl=0 : phits_tmp.inp file)


      rem call %phits_bat%phits.bat phits_tmp.inp
      call %phits_bat% phits_tmp.inp


rem ****************************************************************************************


rem move result files to tallyout folder ( *.out, *_err.out, *.eps )
      for /l %%i in ( 1,1,%nfolder% ) do (
         if /i "!tallyfolder!\!foldercount!\" == "!folder[%%i]!" (
rem            if exist !outname[%%i]!!extname[%%i]! (
rem             move /y !outname[%%i]!!extname[%%i]! !folder[%%i]! > NUL 2>&1
rem            )
rem            if exist !outname[%%i]!_err!extname[%%i]! (
rem             move /y !outname[%%i]!_err!extname[%%i]! !folder[%%i]! > NUL 2>&1
rem            )
rem            if exist !outname[%%i]!.eps (
rem             move /y !outname[%%i]!.eps !folder[%%i]! > NUL 2>&1
rem            )
rem            if exist !outname[%%i]!_err.eps (
rem             move /y !outname[%%i]!_err.eps !folder[%%i]! > NUL 2>&1
rem            )
            if exist *.out (
             move /y *.out !folder[%%i]! > NUL 2>&1
             move /y !folder[%%i]!batch_a.out batch_a.out > NUL 2>&1
            )
            if exist *.eps (
             move /y *.eps !folder[%%i]! > NUL 2>&1
            )
         )
      )

rem move input files and other output files
      for /l %%i in ( 1,1,%nfolder% ) do (
         if /i "!tallyfolder!\!foldercount!\" == "!folder[%%i]!" (
            if exist phits_tmp.inp (
             copy /y phits_tmp.inp "!folder[%%i]!\phits.inp" > NUL 2>&1
            )
            if exist varfile.inp (
             copy /y varfile.inp !folder[%%i]! > NUL 2>&1
            )
            if exist phits.out (
             move /y phits.out !folder[%%i]! > NUL 2>&1
            )
            if exist batch.out (
             move /y batch.out !folder[%%i]! > NUL 2>&1
            )
         )
      )


      rem variable parameter loop count up
      set /a counter+=1
      goto AnaStart
   :AnaEnd
rem ------------------------- end of loop of variable parameter ----------------------------


rem ****************************************************************************************
rem check the result of one cycle (icntl=17 : anatally.inp)

   if %nanatally% gtr 0 (

      rem call %phits_bat%\phits.bat anatally.inp
      call %phits_bat% anatally.inp

   ) else if %nanatally% equ 0 (
      if exist anatally.inp (
         del anatally.inp
      )
   )

rem ****************************************************************************************


rem analysis loop counter check ( external loop variable )
   if not exist batch_a.out (
      goto CycleEnd
    )
   for /f %%a in ( batch_a.out ) do (
      if %%a equ 0 (
         goto CycleEnd
      )
   )


   rem analysis loop count up
   set /a i_cycle+=1
   goto CycleStart
:CycleEnd
rem ============================== end of loop of analysis =================================

rem cleanup current folder
if exist phits_tmp.inp (
   del phits_tmp.inp
)
if exist anatally_tmp.inp (
   del anatally_tmp.inp
)
if exist nc_info.inp (
   del nc_info.inp
)
if exist varfile*.inp (
   del varfile*.inp
)
if exist batch_a.out (
   del batch_a.out
)

rem making eps files.
for /l %%i in ( 1,1,%nsfile% ) do (
   if exist !wsfile[%%i]! (
      call "c:\phits\bin\angel.bat" !wsfile[%%i]!
   )
)

echo FINISHED %~nx0
pause
rem timeout /t -1

exit /b 0


goto :EOF


rem @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ subroutine @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

rem _____ split read line _____
:SPLIT
set fd=%~1
set dc=0
set word=
:SLoopS
   if "%fd%" == "" goto SLoopE
   
   set c=%fd:~0,1%
   set fd=%fd:~1%
   if "%c%" == " " goto SLoopE
   if "%c%" == "," goto SLoopE
   if "%c%" == ":" goto SLoopE
   if "%c%" == "=" goto SLoopE
   
   set word=%word%%c%
   goto SLoopS
:SLoopE
if not "%word%" == "" (
   set /a dc+=1
   set d[!dc!]=!word!
   set word=
   goto SLoopS
) else if not "%fd%" == "" (
   goto SLoopS
)
:SplitEnd
exit /b 0

goto :EOF


:FileName
set fd=%~1
:LoopS
   if "%fd%" == "" goto LoopE 
   set c=%fd:~-1,1%
   if "%c%" == "/" goto LoopE 
   if "%c%" == "\" goto LoopE 
   set fd=%fd:~0,-1%
   goto LoopS
:LoopE
set folder[!nfolder!]=%fd:/=\%
set fname=%~nx1
set outname[!nfolder!]=%~n1
set extname[!nfolder!]=%~x1
set fd=
set c=
exit /b 0

goto :EOF

rem @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

timeout /t -1

exit /b 0
